
;dTest Include File - DednDave, 2-2011

        .XCREF
        .NOLIST
;#############################################################################################################

; Preamble

;*************************************************************************************************************

        .686p
        .MODEL  Flat,StdCall
        OPTION  CaseMap:None
        .MMX
        .XMM

;#############################################################################################################

; Includes

;*************************************************************************************************************

        INCLUDE    \masm32\include\windows.inc
        INCLUDE    \masm32\include\kernel32.inc
        INCLUDE    \masm32\include\shell32.inc
        INCLUDE    \masm32\include\user32.inc
        INCLUDE    \masm32\include\comctl32.inc
        INCLUDE    \masm32\include\comdlg32.inc
        INCLUDE    \masm32\include\gdi32.inc
;        INCLUDE    \masm32\include\shlwapi.inc
;        INCLUDE    \masm32\include\advapi32.inc
;        INCLUDE    \masm32\include\ole32.inc
;        INCLUDE    \masm32\include\oleaut32.inc
;        INCLUDE    \masm32\include\msimg32.inc
        INCLUDE    \masm32\include\msvcrt.inc
        INCLUDE    \masm32\include\masm32.inc
        INCLUDE    \masm32\macros\macros.asm
;        INCLUDE    \masm32\include\dialogs.inc
;        INCLUDE    \masm32\macros\timers.asm

        INCLUDELIB \masm32\lib\kernel32.lib
        INCLUDELIB \masm32\lib\shell32.lib
        INCLUDELIB \masm32\lib\user32.lib
        INCLUDELIB \masm32\lib\comctl32.lib
        INCLUDELIB \masm32\lib\comdlg32.lib
        INCLUDELIB \masm32\lib\gdi32.lib
;        INCLUDELIB \masm32\lib\shlwapi.lib
;        INCLUDELIB \masm32\lib\advapi32.lib
;        INCLUDELIB \masm32\lib\ole32.lib
;        INCLUDELIB \masm32\lib\oleaut32.lib
;        INCLUDELIB \masm32\lib\msimg32.lib
        INCLUDELIB \masm32\lib\msvcrt.lib
        INCLUDELIB \masm32\lib\masm32.lib

        .LIST
;#############################################################################################################

; Prototypes

;*************************************************************************************************************

WndProc      PROTO :HWND,:UINT,:WPARAM,:LPARAM
TxtProc      PROTO :HWND,:UINT,:WPARAM,:LPARAM
CbCopy       PROTO :UINT
CBTProc      PROTO :UINT,:WPARAM,:LPARAM
dTxtOut      PROTO :LPSTR
dClrLine     PROTO :UINT,:UINT
HFree        PROTO :LPVOID
pCalc        PROTO :UINT,:UINT,:UINT,:UINT,:UINT,:UINT,:UINT
ScnMetric    PROTO :UINT,:UINT,:LONG,:LONG,:LONG,:LONG
OpnFile      PROTO :LPSTR,:DWORD
DeRef        PROTO :LPVOID,:LPVOID,:LPVOID
SzLen        PROTO :LPSTR
DlgThread    PROTO :LPVOID,:LPVOID,:UINT
CreateThrd   PROTO :DWORD,:LPVOID,:LPVOID
OFNProc      PROTO :HWND,:UINT,:WPARAM,:LPARAM
FSaveAs      PROTO
CColor       PROTO
HHelp        PROTO
HAbout       PROTO
AckThrd      PROTO
PrnThrd      PROTO
UsrThrd      PROTO

B2Hex        PROTO :UINT,:LPSTR
OpnPres      PROTO :UINT,:UINT
SndData      PROTO :UINT,:UINT,:LPVOID
SndCtrl      PROTO :UINT,:UINT
SndAck       PROTO :UINT
pTxtOut      PROTO :LPSTR

;#############################################################################################################

; Structures

;*************************************************************************************************************

IFNDEF  MENUBARINFO
MENUBARINFO STRUCT
  cbSize      dd ?
  rcBar       RECT <>
;   left        dd ?
;   top         dd ?
;   right       dd ?
;   bottom      dd ?
  hMenu       dd ?
  hwndMenu    dd ?
  fFocus      dd ?
MENUBARINFO ENDS
ENDIF

IFNDEF   OFNOTIFY
OFNOTIFY STRUCT
  hdr      NMHDR <>
;   hwndFrom dd ?
;   idFrom   dd ?
;   code     dd ?
  lpOFN    dd ?
  pszFile  dd ?
OFNOTIFY ENDS
ENDIF

ProcessHandles STRUCT
  hInstance      HANDLE ?
  hIcon          HANDLE ?
  hCursor        HANDLE ?
ProcessHandles ENDS

ControlHandles STRUCT
  hStatus        HWND ?
  hHScroll       HWND ?
  hVScroll       HWND ?
  hSizeBoxNG     HWND ?
  hSizeBoxG      HWND ?
  hTxt           HWND ?
ControlHandles ENDS

DisplayBufferInfo STRUCT
  BufferColumns     dd ?
  BufferRows        dd ?
  hHeap             dd ?
  hDisplayBuf       dd ?
  lpDisplayBuf      dd ?
  RowLength         dd ?    ;(BufferColumns+5) AND 0FFFFFFFCh
  BufCalc1          dd ?    ;RowLength/4
  BufCalc2          dd ?    ;BufferRows-1
  BufCalc3          dd ?    ;RowLength*(BufferRows-1)/4
  BufCalc4          dd ?    ;RowLength*BufferRows/4
  SecondRowAddr     dd ?    ;address of second buffer row
  LastRowAddr       dd ?    ;address of last buffer row
DisplayBufferInfo ENDS

CoordInfo STRUCT
  s         SCROLLINFO <>
;   cbSize    dd ?
;   fMask     dd ?
;   nMin      dd ?
;   nMax      dd ?
;   nPage     dd ?
;   nPos      dd ?
;   nTrackPos dd ?
  CellsUsed dd ?
  CellSize  dd ?
  Mult      dd ?
  Shft      dd ?
  CurPos    dd ?
  NewPos    dd ?
  BarSize   dd ?
  WheelDiv  dd ?
  WheelCnt  dd ?
CoordInfo ENDS

CoordinateGroup STRUCT
  h               CoordInfo <>
  v               CoordInfo <>
CoordinateGroup ENDS

ResetValuesStruct  STRUCT
  LocCntX            dd ?    ;initialized to 0
  LocCntY            dd ?    ;initialized to 0
  SequenceX          dd ?    ;initialized to 0
  SequenceR          dd ?    ;initialized to 0
  MinFlag            dd ?    ;initialized to 0
  WrFlag             db ?    ;initialized to 0
  WheelKeys          db ?    ;initialized to 0
  dUpdateMode        db ?    ;0=manual, 1=semi-auto (update on each newline), 3=full-auto (newline or exit dTxtOut)
  dUpdateFlags       db ?    ;initialized to 0
  sUpdateEnable      db ?    ;initialized to 0
  BufDisable         db ?    ;initialized to 0
  FSSemaphore        db ?    ;file save semaphore, initialized to 0
  CCSemaphore        db ?    ;color chooser semaphore, initialized to 0
  HHSemaphore        db ?    ;help-help semaphore, initialized to 0
  HASemaphore        db ?    ;help-about semaphore, initialized to 0
  rPSemaphore        db ?    ;initialized to 0
                     db ?    ;alignment pad, initialized to 0
ResetValuesStruct  ENDS

PresetValuesStruct STRUCT
  TxtWidth           dd ?    ;initialized to -1
  TxtHeight          dd ?    ;initialized to -1
  BsgPosX            dd ?    ;initialized to -1
  BsgPosY            dd ?    ;initialized to -1
  BngPosX            dd ?    ;initialized to -1
  BngPosY            dd ?    ;initialized to -1
  MaxFlag            dd ?    ;initialized to -1
  SizeID             dd ?    ;initialized to -1
  WinStates          dd ?    ;initialized to 1 = CID_STATUSBAR and STATE_MASK
  SeqFlush           dd ?    ;initialized to 1 (non-zero count)
PresetValuesStruct ENDS

SavedSettingsFile STRUCT
  szMarker          db 10 dup(?) ;'dTest.bin',0
  wFileSize         dw ?         ;120
  wWindowWidth      dw ?
  wWindowHeight     dw ?
  wFlagsTextSize    dw ?
  rgbBackColor      db 3 dup(?)
  rgbForeColor      db 3 dup(?)
  rgbCustomBack     db 48 dup(?)
  rgbCustomFore     db 48 dup(?)
SavedSettingsFile ENDS

ViewSettings    STRUCT
  WndWidth        dd ?
  WndHeight       dd ?
  DefaultTextSize dd ?
  BackColor       dd ?
  ForeColor       dd ?
ViewSettings    ENDS

ColorStruct STRUCT
  Color0      COLORREF ?
  Color1      COLORREF ?
  Color2      COLORREF ?
  Color3      COLORREF ?
  Color4      COLORREF ?
  Color5      COLORREF ?
  Color6      COLORREF ?
  Color7      COLORREF ?
  Color8      COLORREF ?
  Color9      COLORREF ?
  ColorA      COLORREF ?
  ColorB      COLORREF ?
  ColorC      COLORREF ?
  ColorD      COLORREF ?
  ColorE      COLORREF ?
  ColorF      COLORREF ?
ColorStruct ENDS

ColorGroup STRUCT
  BackColors ColorStruct <>
  ForeColors ColorStruct <>
ColorGroup ENDS

;COPYDATASTRUCT STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

CopyDataHdr STRUCT
  hXmtr       dd ?          ;verification Xmtr handle (must match both wParam and stored window handle)
  hRcvr       dd ?          ;verification Rcvr handle (must match both dwData and stored window handle)
  nSequence   dd ?          ;serializing sequence number, 1 to FFFFFFFFh with skip-zero rollover
  dwCommand   dd ?          ;command, followed by command-dependant variable length data
CopyDataHdr ENDS

AppModeStruct STRUCT
  hRcvr         dd ?        ;hPma or hUsr (handles)
  nBaseCmd      dd ?        ;dCU_Base or dCP_Base (equates)
  nMaxCmd       dd ?        ;dCU_MaxCmd or dCP_MaxCmd (equates)
  lpCmdVect     dd ?        ;command dispatch vector table
  AppNamePtr    dd ?        ;pointer to AppName string
  nPmaBaseCmd   dd ?
  nPmaMaxCmd    dd ?
  lpPmaCmdVect  dd ?
  PmaAppNamePtr dd ?
AppModeStruct ENDS

;#############################################################################################################

; Macros

;*************************************************************************************************************

uPrint  MACRO   arg1:REQ,varname:VARARG

        INVOKE  dTxtOut,reparg(arg1)

        IFNB    <varname>
        INVOKE  dTxtOut,chr$(varname)
        ENDIF

        ENDM

;*************************************************************************************************************

dPrint  MACRO   arg1:REQ,varname:VARARG

        INVOKE  pTxtOut,reparg(arg1)

        IFNB    <varname>
        INVOKE  pTxtOut,chr$(varname)
        ENDIF

        ENDM

;#############################################################################################################

; Equates

;*************************************************************************************************************

;misc

MAIN_MENU_ITEMS    EQU 4                                                  ;number of items on main menu
COPY_MODE          EQU 17                                                 ;1 for null term, 16 for extras
HvOfs              EQU CoordinateGroup.v-CoordinateGroup.h                ;= sizeof CoordInfo = 64
BfOfs              EQU ColorGroup.ForeColors-ColorGroup.BackColors        ;= sizeof ColorStruct = 64

;*************************************************************************************************************

;control ID's

IDI_ICON           EQU 501

IDM_FILE_SAVEAS    EQU 32
IDM_FILE_EXIT      EQU 33
IDM_HELP_HELP      EQU 34
IDM_HELP_ABOUT     EQU 35
IDM_EDIT_COPYALL   EQU 36
IDM_EDIT_COPYFORUM EQU IDM_EDIT_COPYALL+11 ;(47) difference in clipboard all/forum data bytes = 11
IDM_FORE_COLOR     EQU 37
IDM_BACK_COLOR     EQU 38
IDM_VIEW_STATUSBAR EQU 39
IDM_VIEW_RESETBACK EQU 40
IDM_VIEW_RESETFORE EQU 41
IDM_VIEW_MWSHFTVRT EQU 42
IDM_VIEW_MWCTRLVRT EQU 43
IDM_VIEW_MWHRZ     EQU 44
IDM_VIEW_MWSHFTHRZ EQU 45
IDM_TEXT_SIZE      EQU 65

CID_STATUSBAR      EQU 1001h ;4097
CID_HSCROLLBAR     EQU 1002h ;4098
CID_VSCROLLBAR     EQU 1004h ;4100
CID_SIZEBOXN       EQU 1008h ;4104
CID_SIZEGRIP       EQU 1010h ;4112
CID_TEXTWIN        EQU 1020h ;4128

STATE_MASK EQU (CID_STATUSBAR or CID_HSCROLLBAR or CID_VSCROLLBAR or CID_SIZEBOXN or CID_SIZEGRIP) and 0FFh

;*************************************************************************************************************

;display update mode controls

DMODE_NEWLINE      EQU 1                                      ;new line display update mode bit
DMODE_CLEARLINE    EQU 2                                      ;clear line display update mode bit
DMODE_TEXTOUT      EQU 4                                      ;text out display update mode bit

;display update modes

DMODE_MANUAL       EQU 0                                      ;manual display update mode
DMODE_SEMI_AUTO    EQU DMODE_NEWLINE or DMODE_CLEARLINE       ;semi-auto display update mode
DMODE_FULL_AUTO    EQU DMODE_SEMI_AUTO or DMODE_TEXTOUT       ;full-auto display update mode
DMODE_FORCE_UPDATE EQU 100h                                   ;force update on mode change

;test mask

DMODE_MASK         EQU DMODE_FULL_AUTO or DMODE_FORCE_UPDATE  ;test mask

;*************************************************************************************************************

;file open flag sets

OPF_FILECREATE     EQU GENERIC_WRITE or CREATE_ALWAYS                  ;40000002h
OPF_FILEWRITE      EQU GENERIC_WRITE or OPEN_EXISTING                  ;40000003h
OPF_FILEREAD       EQU GENERIC_READ or OPEN_EXISTING                   ;80000003h
OPF_FILERANDOM     EQU GENERIC_READ or GENERIC_WRITE or OPEN_EXISTING  ;C0000003h

;*************************************************************************************************************

;wheel keys

WKEY_SHIFT         EQU 4
WKEY_CONTROL       EQU 8
WKEY_ALT           EQU 10h
WKEY_MLOOP         EQU 20h

;*************************************************************************************************************

;font enumeration list length

FELISTLENGTH       EQU 16

;*************************************************************************************************************

;colors in COLORREF form

MyBlack_0     EQU 00000000h ;standard is             00000000h (00bbggrr)
MyBlue_1      EQU 007F0000h ;standard supposed to be 00AA0000h
MyGreen_2     EQU 00007F00h ;standard supposed to be 0000AA00h
MyCyan_3      EQU 007F7F00h ;standard supposed to be 00AAAA00h
MyRed_4       EQU 0000007Fh ;standard supposed to be 000000AAh
MyMagenta_5   EQU 007F007Fh ;standard supposed to be 00AA00AAh
MyAmber_6     EQU 00007FFFh ;standard supposed to be 000055AAh (brown)
MyLtGrey_7    EQU 00AAAAAAh ;standard is             00AAAAAAh
MyGrey_8      EQU 00555555h ;standard is             00555555h
MyLtBlue_9    EQU 00FF0000h ;standard supposed to be 00FF5555h
MyLtGreen_A   EQU 0000FF00h ;standard supposed to be 0055FF55h
MyLtCyan_B    EQU 00FFFF00h ;standard supposed to be 00FFFF55h
MyLtRed_C     EQU 000000FFh ;standard supposed to be 005555FFh
MyLtMagenta_D EQU 00FF00FFh ;standard supposed to be 00FF55FFh
MyYellow_E    EQU 0000FFFFh ;standard supposed to be 0055FFFFh
MyWhite_F     EQU 00FFFFFFh ;standard is             00FFFFFFh

;*************************************************************************************************************

;SetWindowPos/DeferWindowPos flag set

SP_FLAGSET         EQU SWP_NOZORDER or SWP_NOACTIVATE or SWP_NOOWNERZORDER

;SWP_NOZORDER       EQU 0004h
;Retains the current Z order (ignores the hWndInsertAfter parameter).
;
;SWP_NOACTIVATE     EQU 0010h
;Does not activate the window. If this flag is not set, the window is activated and moved to the top of 
;either the topmost or non-topmost group (depending on the setting of the hWndInsertAfter parameter).
;
;SWP_NOCOPYBITS     EQU 0100h
;Discards the entire contents of the client area. If this flag is not specified, the valid contents of 
;the client area are saved and copied back into the client area after the window is sized or repositioned.
;
;SWP_NOOWNERZORDER  EQU 0200h
;Does not change the owner window's position in the Z order.
;
;SWP_NOSENDCHANGING EQU 0400h
;Prevents the window from receiving the WM_WINDOWPOSCHANGING message.

;*************************************************************************************************************

cdTIMEOUT       EQU 3000             ;5 mS steps, 3000 = 15 seconds

;commands recieved and processed by the presentation mode app

dCP_Base        EQU 18000h
dCU_Base        EQU 1C000h

dCP_ACKNOWLEDGE EQU dCP_Base+0
dCP_CONTINUE    EQU dCP_Base+4
dCP_FLUSH       EQU dCP_Base+8
dCP_PRINT       EQU dCP_Base+0Ch

dCP_MaxCmd      EQU dCP_PRINT

;commands recieved and processed by the user mode app

dCU_ACKNOWLEDGE EQU dCU_Base+0
dCU_CONTINUE    EQU dCU_Base+4
dCU_FLUSH       EQU dCU_Base+8

dCU_MaxCmd      EQU dCU_FLUSH

;#############################################################################################################

;end of include file

